/***************************************************************
  MantisChessStd.cpp : MantisChess ׼

  Ȩ(C)  ³

  һGNUͨù
  ֤޸ĺ·һ򡣻֤ĵڶ棬
  (ѡ)κθµİ汾

  һĿϣãûκεûʺ
  ĿĵĵϸGNUͨù֤
  
  ӦѾͳһյһGNUͨù֤ĸ
  ûУдŸ

  The Free Software FoundationInc675 Mass Ave Cambridge
  MAO2139USA

  ʹñʱʲô飬µַȡ
  ϵ

              http://thecct.51.net

  Email

              stove@eyou.com
              thecct@163.com

------------------------------------------------------------------
  MantisChessStd.cpp : MantisChess standard functions

  Copyright (C)  Chen Chengtao, China
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  
  If you have any question about this software please visit my hompage:

              http://thecct.51.net

  or E_mail to:

              stove@eyou.com
              thecct@163.com

******************************************************************/

#include "StdAfx.h"
#include "MantisChessDef.h"
#include "MantisChessStd.h"

/******************************************************************
CanGo:		жһϲϷ

:
manmap:		λ״̬
man:		ƶ
from:		ƶԭʼλ
to:			Ҫƶλ

ֵ:		ϷTRUE,ϷFALSE
******************************************************************/
BOOL  CanGo(int manmap[11][12],int man,const POINT &from,const POINT &to)
{
	static int i,j;

	if(!IsNormal(ManToType[man],to))	//ӲܷĿλ
	{
		//ǽ/˧ (/˧"")
		if(ManToType[man]!=RED_K&& ManToType[man]!=BLACK_K)return FALSE;

		else if(ManToType[man]==RED_K &&			//ߵ˧
			ManToType[manmap[to.x][to.y]]==BLACK_K)	//Ŀǽ
		{
			BOOL flag=FALSE;
			for(j= from.y-1;j>0;j--)
			{
				if (manmap[from.x][j]!=32)
				{
					if(ManToType[manmap[from.x][j]]==BLACK_K)	//
						flag=TRUE;
					break;				
				}
			}
			if(flag)return TRUE;
			else return FALSE;
		}
		else if(ManToType[manmap[to.x][to.y]]==RED_K)	//ߵǽ,Ŀ˧							
		{
			BOOL flag=FALSE;
			for(j= from.y+1;j<11;j++)
			{
				if (manmap[from.x][j]!=32)
				{
					if(ManToType[manmap[from.x][j]]==RED_K)	//
						flag=TRUE;	
					break;
				}
			}
			if(flag)return TRUE;
			else return FALSE;
		}
		else return FALSE;
	}

	//漸жĿǷ񼺷:
	if(SideOfMan[man]==0)
	{
		if(manmap[to.x][to.y]!=32&& SideOfMan[manmap[to.x][to.y]]==0)return FALSE;		
	}
	else if(SideOfMan[man]==1)
	{
		if(manmap[to.x][to.y]!=32&& SideOfMan[manmap[to.x][to.y]]==1)return FALSE;		
	}
	//--------------------------------

	//ǸӵĹ:
	switch(ManToType[man])	
		{
		case RED_B:
			//ͷ:
			if(to.y > from.y)return FALSE;
			//ֻһֱ:
			if(from.y-to.y+abs(to.x-from.x)>1)return FALSE;	
			break;

		case BLACK_B:
			//䲻ͷ:
			if(to.y < from.y)return FALSE;
			//ֻһֱ:
			if(to.y-from.y+abs(to.x-from.x)>1)return FALSE;	
			break;

		case RED_S:
		case BLACK_S:
			//ʿбһ:
			if(abs(from.y-to.y)>1||abs(to.x-from.x)>1)return FALSE;	
			break;

		case RED_X:
		case BLACK_X:
			//:
			if(abs(from.x-to.x)!=2||abs(from.y-to.y)!=2)return FALSE;
			//:
			if(manmap[(from.x+to.x)/2][(from.y+to.y)/2]!=32)return FALSE;
			break;

		case RED_K:
		case BLACK_K:
			//˧ֻһֱ:
			if(abs(from.y-to.y)+abs(to.x-from.x)>1)return FALSE;
			break;

		case RED_J:
		case BLACK_J:
			//ֱֻ:
			if(from.y!=to.y&&from.x!=to.x)return FALSE;	
			//·в: -----------
			if(from.y==to.y)
			{
				if(from.x<to.x)
				{
					for(i=from.x+1;i<to.x;i++)
						if(manmap[i][from.y]!=32)return FALSE;
				}
				else
				{
					for(i=to.x+1;i<from.x;i++)
						if(manmap[i][from.y]!=32)return FALSE;
				}
			}
			else
			{
				if(from.y<to.y)
				{
					for(j=from.y+1;j<to.y;j++)
						if(manmap[from.x][j]!=32)return FALSE;
				}
				else
				{
					for(j=to.y+1;j<from.y;j++)
						if(manmap[from.x][j]!=32)return FALSE;
				}
			}
			//ǳ---------------------------------
			break;

		case RED_P:
		case BLACK_P:
			//ֱֻ:
			if(from.y!=to.y&&from.x!=to.x)return FALSE;	
			//ڲʱ·в:------------------
			if(manmap[to.x][to.y]==32)
			{
				if(from.y==to.y)
				{
					if(from.x<to.x)
					{
						for(i=from.x+1;i<to.x;i++)
							if(manmap[i][from.y]!=32)return FALSE;
					}
					else
					{
						for(i=to.x+1;i<from.x;i++)
							if(manmap[i][from.y]!=32)return FALSE;
					}
				}
				else
				{
					if(from.y<to.y)
					{
						for(j=from.y+1;j<to.y;j++)
							if(manmap[from.x][j]!=32)return FALSE;
					}
					else
					{
						for(j=to.y+1;j<from.y;j++)
							if(manmap[from.x][j]!=32)return FALSE;
					}
				}
			}
			//ڲ-------------------------------------
			//ʱ:=======================================
			else	
			{
				int count=0;
				if(from.y==to.y)
				{
					if(from.x<to.x)
					{
						for(i=from.x+1;i<to.x;i++)
							if(manmap[i][from.y]!=32)count++;
						if(count!=1)return FALSE;
					}
					else
					{
						for(i=to.x+1;i<from.x;i++)
							if(manmap[i][from.y]!=32)count++;
						if(count!=1)return FALSE;
					}
				}
				else
				{
					if(from.y<to.y)
					{
						for(j=from.y+1;j<to.y;j++)
							if(manmap[from.x][j]!=32)count++;
						if(count!=1)return FALSE;
					}
					else
					{
						for(j=to.y+1;j<from.y;j++)
							if(manmap[from.x][j]!=32)count++;
						if(count!=1)return FALSE;
					}
				}
			}
			//ڳʱ================================
			break;	

		case RED_M:
		case BLACK_M:
			//:
			if(!(
				(abs(to.x-from.x)==1&&abs(to.y-from.y)==2)
				||(abs(to.x-from.x)==2&&abs(to.y-from.y)==1)
				))return FALSE;
			
			//:
			if		(to.x-from.x==2){i=from.x+1;j=from.y;}
			else if	(from.x-to.x==2){i=from.x-1;j=from.y;}
			else if	(to.y-from.y==2){i=from.x;j=from.y+1;}
			else if	(from.y-to.y==2){i=from.x;j=from.y-1;}
			
			//:
			if(manmap[i][j]!=32)return FALSE;
			break;

		default:	
			break;
		}

	return TRUE;	//Ĺȫͨ!
}

/******************************************************************
IsNormal:		mantype͵ӷpointλǷϷ

:
mantype:		
point:			λ

ֵ:			ϷTRUE,ϷFALSE
******************************************************************/
BOOL  IsNormal(const int & mantype,const POINT &point)
{
	if(point.x<1||point.x>9||point.y<1||point.y>10)return FALSE;
	switch(mantype)
	{
	case RED_K:	
		//˧ں췽:
		if( point.x>6|| point.x<4|| point.y<8)return FALSE;
		break;

	case RED_S:	
		//ֻڹض:
		if(!(
			( point.x==4&& point.y==10)||
			( point.x==4&& point.y==8)||
			( point.x==5&& point.y==9)||
			( point.x==6&& point.y==10)||
			( point.x==6&& point.y==8)
			))return FALSE;
		break;

	case RED_X:
		//߸λ:
		if(!(
			( point.x==1&& point.y==8)||
			( point.x==3&& point.y==10)||
			( point.x==3&& point.y==6)||
			( point.x==5&& point.y==8)||
			( point.x==7&& point.y==10)||
			( point.x==7&& point.y==6)||
			( point.x==9&& point.y==8)
			))return FALSE;
		break;

	case RED_B:
		//ڱλ:
		if( point.y>7)return FALSE;
		//ǰƶ:
		if( point.y>5&& point.x%2==0)return FALSE;
		break;

	case BLACK_K:
		//˧ں췽:
		if( point.x>6|| point.x<4|| point.y>3)return FALSE;
		break;

	case BLACK_S:
		//ֻڹض:
		if(!(
			( point.x==4&& point.y==1)||
			( point.x==4&& point.y==3)||
			( point.x==5&& point.y==2)||
			( point.x==6&& point.y==1)||
			( point.x==6&& point.y==3)
			))return FALSE;
		break;

	case BLACK_X:
		//߸λ:
		if(!(
			( point.x==1&& point.y==3)||
			( point.x==3&& point.y==1)||
			( point.x==3&& point.y==5)||
			( point.x==5&& point.y==3)||
			( point.x==7&& point.y==1)||
			( point.x==7&& point.y==5)||
			( point.x==9&& point.y==3)
			))return FALSE;
		break;

	case BLACK_B:
		//ڱλ:
		if( point.y<4)return FALSE;
		//ǰƶ:
		if( point.y<6&& point.x%2==0)return FALSE;
		break;

	default:
		break;
	}
	return TRUE;
}

/******************************************************************
FixManMap:		λ״̬

:
map:			λ״̬(Ž)
manpoint:		
side:			ֵһ

ֵ:			
******************************************************************/
void  FixManMap(int map[11][12],POINT manpoint[32],int side)
{
	memcpy(map,_defaultmap,132*sizeof(int));

	static POINT * pman;
	static int i;
	for(i=0;i<32;i++)
	{
		pman = & manpoint[i];
		if(pman->x)
			map[pman->x][pman->y]=i;
	}
}
